Bug 51174 - SSLRequire predicates using OIDs unknown to openssl
Summary: SSLRequire predicates using OIDs unknown to openssl
Status: RESOLVED LATER
Alias: None
Product: Apache httpd-2
Classification: Unclassified
Component: mod_ssl (show other bugs)
Version: 2.2.17
Hardware: All Linux
: P2 minor (vote)
Target Milestone: ---
Assignee: Apache HTTPD Bugs Mailing List
URL:
Keywords: MassUpdate
Depends on:
Blocks:
 
Reported: 2011-05-09 08:39 UTC by Daniele Gozzi
Modified: 2018-11-07 21:08 UTC (History)
1 user (show)



Attachments
"works for me" patch (542 bytes, application/octet-stream)
2011-05-09 08:39 UTC, Daniele Gozzi
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Daniele Gozzi 2011-05-09 08:39:49 UTC
Created attachment 26975 [details]
"works for me" patch

By calling X509V3_EXT_print() with a null flags argument in modules/ssl/ssl_expr_eval.c: ssl_extlist_by_oid() it is not possible to express conditions on arbitrary OIDs, as in 

SSLRequire file("/a/file") in OID("1.3.6.1.4.1.311.21.10")

I propose the attached patch to address the problem.

Be aware that the OID values in val_array are compared using strcmp() in ssl_expr_eval_oid(), so a null byte may disrupt the check. I wasn't able to find evidence about the chance of having a null byte in ASN.1, so the patch only counts as a "works for me" solution.
Comment 1 Joe Orton 2012-08-17 12:45:19 UTC
This is done, though slightly differently, in 2.4.x; thanks for sending in the patch.
Comment 2 William A. Rowe Jr. 2018-11-07 21:08:37 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.